﻿using System.Text.Json.Serialization;

namespace SWAD.API.Models.JsonStructures.MusicAPI.Spotify;

/// <summary>
///     Json Structure for spotify search response
/// </summary>
internal class SpotifySearchResponse
{
    // ReSharper disable NullableWarningSuppressionIsUsed
    [JsonPropertyName("tracks")] public TrackList Tracks { get; set; } = null!;

    public class TrackList
    {
        [JsonPropertyName("items")] public List<Item> Items { get; set; } = null!;
    }

    public class ExternalUrls
    {
        [JsonPropertyName("spotify")] public string Spotify { get; set; } = null!;
    }

    public class Item
    {
        [JsonPropertyName("href")] public string? Href { get; set; } = null!;

        [JsonPropertyName("id")] public string? Id { get; set; } = null!;

        [JsonPropertyName("external_urls")] public ExternalUrls ExternalUrls { get; set; } = null!;
    }
}